<?php
/*
Created by the TruthMedia Internet Group
(website: truthmedia.com       email : webmaster@truthmedia.com)

Plugin Programming and Design by James Warkentin
http://www.warkensoft.com/about-me/

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
 	function formbuilder_options_default()
 	{
 		global $wpdb;
		$relative_path = FORMBUILDER_PLUGIN_URL;
		include('html/options_default.inc.php');
 	}

 	function formbuilder_options_newForm()
 	{
		global $wpdb;
		$sql =  "INSERT INTO " . FORMBUILDER_TABLE_FORMS . "(" .
					"`name`," .
					"`subject`," .
					"`recipient`," .
					"`thankyoutext`" .
				") VALUES (" .
					"'" . __('New Form', 'formbuilder') . "', " .
					"'" . __("Generic Website Feedback Form", 'formbuilder') . "', " .
					"'" . get_option('admin_email') . "', " .
					"''" .
				");";
		
		if($wpdb->query($sql) !== false)
		{
			$insert_id = $wpdb->insert_id;
			
			$sql = 	"INSERT INTO `" . FORMBUILDER_TABLE_FIELDS . "` (`form_id`, `display_order`, `field_type`, `field_name`, `field_value`, `field_label`, `required_data`, `error_message`) VALUES " .
					"($insert_id, 1, 'single line text box', 'Name', '', 'Name', 'any text', 'You must enter your name.'), " .
					"($insert_id, 2, 'single line text box', 'Email', '', 'Email', 'email address', 'You must enter your email address.'), " .
					"($insert_id, 3, 'large text area', 'Comments', '', 'Comments', '', '');";
			if($wpdb->query($sql) !== false)
				formbuilder_options_default();
			else
				formbuilder_admin_alert(__("Unable to create new form fields.  Attempted to run the following SQL: ", 'formbuilder'), $sql);
		}
		else
		{
			formbuilder_admin_alert(__("Unable to create new form.  Attempted to run the following SQL: ", 'formbuilder'), $sql);
		}
 	}

 	function formbuilder_options_editForm($form_id)
 	{
 		global $wpdb;
 		
 		// Make a connection to the database.
		$connection = new connection(DB_HOST, DB_USER, DB_PASSWORD);
		$db = new connectionDatabase($connection, DB_NAME);
		$tableForms = new databaseTable($db, FORMBUILDER_TABLE_FORMS, "id");
		$tableFields = new databaseTable($db, FORMBUILDER_TABLE_FIELDS, "id");
		$tableResponses = new databaseTable($db, FORMBUILDER_TABLE_RESPONSES, "id");

		if(isset($_POST['formbuilder']) AND is_array($_POST['formbuilder']))
		{
			$_POST['formbuilder'] = formbuilder_array_stripslashes($_POST['formbuilder']);
			$_POST['formbuilderfields'] = formbuilder_array_stripslashes($_POST['formbuilderfields']);

			// Verify the data that was posted.
				// No verification currently done on the main form fields.

			// Check to ensure that we can save the form data.  List an error message if not.
			if(!$tableForms->save_row($form_id, $_POST['formbuilder'])) $message = "ERROR.  Your form failed to save.";

			// Check to see if we have any form fields to save, while making sure there are no existing error messages.
			if(isset($_POST['formbuilderfields']) AND is_array($_POST['formbuilderfields']) AND !isset($message))
			{
				// Iterate through the form fields, do verification and save them to the database.
				foreach($_POST['formbuilderfields'] as $key => $value)
				{
					// Verify that the field has appropriate data
					$value['field_name'] = clean_field_name($value['field_name']);

					// Save the form field to the db.
					if(!isset($message))
					{
						if(!$tableFields->save_row($key, $value)) $message = __("ERROR.  Problems were detected while saving your form fields.", 'formbuilder');
					}
				}
			}
			if(isset($_POST['fieldAction']) AND is_array($_POST['fieldAction']))
			{
				$fieldAction = $_POST['fieldAction'];
				$fieldKey = key($fieldAction);
				$fieldValue = current($fieldAction);

				if($fieldValue == __('Add New Field', 'formbuilder'))
				{
					if($fieldKey == "newField")
					{	// Create a new field at the end of the form.
						$relatedRows = $tableFields->search_rows("$form_id", "form_id", "display_order DESC");
						$actionRow = $tableFields->load_row($relatedRows[0]);
						$display_order = $actionRow['display_order'] + 1;

						$rowID = $tableFields->create_row();
						$tableFields->save_row($rowID, array("form_id"=>"$form_id", "display_order"=>$display_order));
					}
					echo "<meta http-equiv='refresh' content='0;url=#field_$rowID' />";
				}
				if($fieldValue == __("Add Another", 'formbuilder'))
				{
					$actionRow = $tableFields->load_row($fieldKey);
					$relatedRows = $tableFields->search_rows("$form_id", "form_id");

					foreach($relatedRows as $tableRowID)
					{
						$row = $tableFields->load_row($tableRowID);
						if($row['display_order'] >= $actionRow['display_order'])
						{
							$row['display_order'] = $row['display_order'] + 1;
							$tableFields->save_row($tableRowID, $row);
						}
					}
					$rowID = $tableFields->create_row();
					$tableFields->save_row($rowID, array("form_id"=>"$form_id", "display_order"=>$actionRow['display_order']));
					echo "<meta http-equiv='refresh' content='0;url=#field_$rowID' />";
				}
				if($fieldValue == __("Delete", 'formbuilder'))
				{
					$actionRow = $tableFields->load_row($fieldKey);
					$relatedRows = $tableFields->search_rows("$form_id", "form_id", "display_order ASC");

					$tableFields->remove_row($fieldKey);
					foreach($relatedRows as $tableRowID)
					{
						$row = $tableFields->load_row($tableRowID);
						if($row['display_order'] > $actionRow['display_order'])
						{
							$row['display_order'] = $row['display_order'] - 1;
							$tableFields->save_row($tableRowID, $row);
						}
					}
					echo "<meta http-equiv='refresh' content='0;url=#field_" . $relatedRows[0]['id'] . "' />";
				}
				if($fieldValue == __("Move Up", 'formbuilder'))
				{
					$actionRow = $tableFields->load_row($fieldKey);
					$relatedRows = $tableFields->search_rows("$form_id", "form_id", "display_order ASC");

					$firstRow = $tableFields->load_row(reset($relatedRows));
					$firstPos = $firstRow['display_order'];

					$current_pos = $actionRow['display_order'];

					if($current_pos > $firstPos)
					{
						$current_pos -= 1;
						$actionRow['display_order'] = $current_pos;

						foreach($relatedRows as $tableRowID)
						{
							$row = $tableFields->load_row($tableRowID);

							if($row['display_order'] == $current_pos)
							{
								$row['display_order'] = $row['display_order'] + 1;
								$tableFields->save_row($tableRowID, $row);
							}
						}
						$tableFields->save_row($fieldKey, $actionRow);
					}
					echo "<meta http-equiv='refresh' content='0;url=#field_$fieldKey' />";
				}
				if($fieldValue == __("Move Down", 'formbuilder'))
				{
					$actionRow = $tableFields->load_row($fieldKey);
					$relatedRows = $tableFields->search_rows("$form_id", "form_id", "display_order DESC");
					$firstRow = $tableFields->load_row(reset($relatedRows));

					$lastPos = $firstRow['display_order'];

					$current_pos = $actionRow['display_order'];

					if($current_pos < $lastPos)
					{
						$current_pos += 1;
						$actionRow['display_order'] = $current_pos;

						foreach($relatedRows as $tableRowID)
						{
							$row = $tableFields->load_row($tableRowID);

							if($row['display_order'] == $current_pos)
							{
								$row['display_order'] = $row['display_order'] - 1;
								$tableFields->save_row($tableRowID, $row);
							}
						}
						$tableFields->save_row($fieldKey, $actionRow);
					}
					echo "<meta http-equiv='refresh' content='0;url=#field_$fieldKey' />";
				}
			}
			if(isset($_POST['Save']) AND !isset($message))
			{
				$message = sprintf(__("Your form has been saved.  %sYou may click here to return to the main FormBuilder options page.%s", 'formbuilder'), "<a href='" . FB_ADMIN_PLUGIN_PATH . "'>", "</a>");
			}

		}
		
		echo " &gt; <a href='" . $_SERVER['REQUEST_URI'] . "'>" . __('Edit Form', 'formbuilder') . "</a>";
		if(isset($message)) echo "<div class='updated'><p><strong>$message</strong></p></div>"; 

		include('html/options_edit_form.inc.php');
 	}

 	function formbuilder_options_copyForm($form_id)
 	{
		global $wpdb;
		
		// Duplicate the main form table row
		$sql = "SELECT * FROM " . FORMBUILDER_TABLE_FORMS . " WHERE id = '$form_id' LIMIT 0,1;";
		$form_data = $wpdb->get_results($sql, ARRAY_A);
		$form_data = $form_data[0];
		
		unset($form_data['id']);
		$form_data['name'] .= __(" (COPY)", 'formbuilder');
		
		$result = $wpdb->insert(FORMBUILDER_TABLE_FORMS, $form_data);
		$new_form_id = $wpdb->insert_id;
		
		// Duplicate all fields on the form, assigning them to the newly created form table row
		$sql = "SELECT * FROM " . FORMBUILDER_TABLE_FIELDS . " WHERE form_id = '$form_id';";
		$related = $wpdb->get_results($sql, ARRAY_A);
		foreach($related as $field)
		{
			unset($field['id']);
			$field['form_id'] = $new_form_id;
			$result = $wpdb->insert(FORMBUILDER_TABLE_FIELDS, $field);
		}

		formbuilder_options_default();
 	}

	function formbuilder_options_removeForm($form_id)
	{
		global $wpdb;
		
		$sql = "DELETE FROM " . FORMBUILDER_TABLE_FORMS . " WHERE id = '$form_id';";
		$wpdb->query($sql);
		
		$sql = "SELECT * FROM " . FORMBUILDER_TABLE_FIELDS . " WHERE form_id = '$form_id';";
		$related = $wpdb->get_results($sql, ARRAY_A);
		if($related) foreach($related as $field)
		{
			$sql = "DELETE FROM " . FORMBUILDER_TABLE_FIELDS . " WHERE id = '" . $field['id'] . "';";
			$wpdb->query($sql);
		}
	}

	// Function to display individual form fields on an HTML page.  $field_info should contain an array describing the field, including any data associated with it.
	function formbuilder_display_form_field($field_info, $prefix = "formbuilder", $template_before = "<div style='padding: 1px 0 2px 20px;'>", $template_mid = ": ", $template_after = "</div>\n")
	{
		$field_name = strtoupper(str_replace("_", " ", $field_info['Field']));
		$field_data = htmlentities($field_info['Value'], ENT_QUOTES, get_option('blog_charset'));

		if(isset($field_info['HelpText'])) $helpText = ' <a href="javascript:;" onClick="alert(\'' . $field_info['HelpText'] . '\');">?</a> ';
		if(isset($helpText)) $template_after = $helpText . $template_after;
		
		if(!isset($field_info['Title'])) $field_info['Title'] = ""; 

		if(eregi("[a-z]+\(([0-9]+)\)", $field_info['Type'], $regs))
		{
			if($regs[1] > 50)  $size = 50;
			else $size = $regs[1];
			$field_details = "<input " .
						"name='" . $prefix . "[" . $field_info['Field'] . "]' " .
						"id='" . $field_info['Field'] . "' " .
						"type='text' " .
						"size='$size' " .
						"maxlength='$regs[1]' " .
						"value='$field_data' " .
						"alt='" . $field_info['Title'] . "' " .
						"title='" . $field_info['Title'] . "' " .
					"/>";
		}

		elseif(eregi("enum\((.+)\)", $field_info['Type'], $regs))
		{
			$enum_values = explode(",", $regs[1]);

			$field_details = "<select " .
						"name='" . $prefix . "[" . $field_info['Field'] . "]' " .
						"id='" . $field_info['Field'] . "' " .
						"alt='" . $field_info['Title'] . "' " .
						"title='" . $field_info['Title'] . "' " .
					">\n";
			foreach($enum_values as $value)
			{
				$value = str_replace("'", "", $value);

				// Check whether or not keys were passed along with the values.
				if(strpos($value, "|") !== false)
				{
					list($key, $value) = explode("|", $value);

				}
				else
					$key = $value;

				if($key == $field_data) $select = "selected";
				else $select = "";

				$field_details .= "<option value='$key' $select>$value</option>\n";
			}
			$field_details .= "</select>";
		}
		elseif(eregi("blob", $field_info['Type']) OR eregi("text", $field_info['Type']) OR eregi("longtext", $field_info['Type']))
		{
			$blob_cols = 52;

			$blob_rows =substr_count(wordwrap($field_data, $blob_cols), "\n");

			if($blob_rows > 30) $blob_rows = 30;
			if($blob_rows <= 2) $blob_rows = 2;

			$field_details = "<textarea " .
						"name='" . $prefix . "[" . $field_info['Field'] . "]' " .
						"id='" . $field_info['Field'] . "' " .
						"cols='$blob_cols' " .
						"rows='$blob_rows' " .
						"alt='" . $field_info['Title'] . "' " .
						"title='" . $field_info['Title'] . "' " .
					">\n$field_data</textarea>";
		}
		else
		{
			$field_details = "Field type not found!";
			print_r($field_info); echo $template_after;

		}

		// Output the actual field data
		echo $template_before . "<span class='formbuilderLabel'>" . $field_name . $template_mid . "</span>" . "<span class='formbuilderField'>$field_details</span>" . $template_after;
	}

	function formbuilder_array_stripslashes($slash_array = array())
	{
		if($slash_array)
		{
			foreach($slash_array as $key=>$value)
			{
				if(is_array($value))
				{
					$slash_array[$key] = formbuilder_array_stripslashes($value);
				}
				else
				{
					$slash_array[$key] = stripslashes($value);
				}
			}
		}
		return($slash_array);
	}
?>
