<?php
/*
Created by the TruthMedia Internet Group
(website: truthmedia.com       email : webmaster@truthmedia.com)

Plugin Programming and Design by James Warkentin
http://www.warkensoft.com/about-me/

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

 	function formbuilder_options_newResponse()
 	{

		$connection = new connection(DB_HOST, DB_USER, DB_PASSWORD);
		$db = new connectionDatabase($connection, DB_NAME);
		$responses = new databaseTable($db, FORMBUILDER_TABLE_RESPONSES, "id");

		$response_id = $responses->create_row();

		$data['name'] = __("New AutoResponse", 'formbuilder');
		$data['subject'] = __("This is a new, empty autoresponse that you can now modify to suit your needs.", 'formbuilder');
		$data['from'] = get_option('admin_email');

		$responses->save_row($response_id, $data);

		formbuilder_options_default();
 	}

 	function formbuilder_options_editResponse($response_id)
 	{
		// Make a connection to the database.
		$connection = new connection(DB_HOST, DB_USER, DB_PASSWORD);
		$db = new connectionDatabase($connection, DB_NAME);
		$tableResponses = new databaseTable($db, FORMBUILDER_TABLE_RESPONSES, "id");
		$message = "";

		if(isset($_POST['formbuilder']) AND is_array($_POST['formbuilder']))
		{
			$_POST['formbuilder'] = formbuilder_array_stripslashes($_POST['formbuilder']);

			// Verify the data that was posted.
				// No verification currently done on the main form fields.

			// Check to ensure that we can save the form data.  List an error message if not.
			if(!$tableResponses->save_row($response_id, $_POST['formbuilder'])) $message = "ERROR.  Your form failed to save.";

			if($_POST['Save'] AND !$message)
			{
				$message = sprintf(__("Your autoresponse has been saved.  %sYou may click here to return to the main FormBuilder options page.%s", 'formbuilder'), "<a href='" . FB_ADMIN_PLUGIN_PATH . "'>", "</a>");
			}

		}

		echo " &gt; <a href='" . $_SERVER['REQUEST_URI'] . "'>" . __("Edit Autoresponse", 'formbuilder') . "</a>";
		if($message) echo "<div class='updated'><p><strong>$message</strong></p></div>"; 

		include('html/options_edit_response.inc.php');
 	}

 	function formbuilder_options_copyResponse($response_id)
 	{

		$connection = new connection(DB_HOST, DB_USER, DB_PASSWORD);
		$db = new connectionDatabase($connection, DB_NAME);
		$tableResponses = new databaseTable($db, FORMBUILDER_TABLE_RESPONSES, "id");

		$fields = $tableResponses->load_row($response_id);

		unset($fields['id']);
		$fields['name'] .= __(" (COPY)", 'formbuilder');

		$new_response_id = $tableResponses->create_row();

		$tableResponses->save_row($new_response_id, $fields);

		formbuilder_options_default();
 	}

	function formbuilder_options_removeResponse($response_id)
	{
		$connection = new connection(DB_HOST, DB_USER, DB_PASSWORD);
		$db = new connectionDatabase($connection, DB_NAME);
		$tableResponses = new databaseTable($db, FORMBUILDER_TABLE_RESPONSES, "id");

		// Remove the form row
		$tableResponses->remove_row($response_id);
	}

?>
